/***********************************************************************
 *   IRC - Internet Relay Chat, src/mkpasswd.c
 *   Copyright (C) 2000 Alasdair McWilliam. RageIRCd, Inc.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern char *getpass();

int main(argc, argv)
	int		argc;
	char		*argv[];
{
	static	char	saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
	char		salt[3];
	char		*plaintext;
	int		i;

	if (argc < 2)
	{
		srandom(time(0));
		salt[0] = saltChars[random() % 64];
		salt[1] = saltChars[random() % 64];
		salt[2] = 0;
	}
	else
	{
		salt[0] = argv[1][0];
		salt[1] = argv[1][1];
		salt[2] = '\0';

		if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
		{
			(void)fprintf(stderr, " \n");
			(void)fprintf(stderr, "ERROR: Illegal salt %s\n", salt);
			(void)fprintf(stderr, " \n");
			exit (1);
		}
	}

	(void)fprintf(stderr, " \n");
	plaintext = getpass("Plain text: ");
	(void)fprintf(stderr, " \n");
	(void)fprintf(stderr, "Encrypted text: %s\n", crypt(plaintext, salt));
	(void)fprintf(stderr, " \n");

	return 0;
}
