spitshell=cat
package=IRC

if test -r version.c
then
   generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c`
   if test ! "$generation" ; then generation=0; fi
else
   generation=0
fi

generation=`expr $generation + 1`
uname=`uname`

creation=`date | \
awk '{if (NF == 6) \
         { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
         { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!
/****************************************************************************
 * IRC - Internet Relay Chat, src/version.c
 * Copyright (C) 2000 Alasdair McWilliam. RageIRCd, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "patchlevel.h"

char	*generation = "$generation";
char	*creation = "$creation";
char	*unametext = "$uname";
char	*version = IRCD_VERSION;

char	*infotext[] =
{
	" ",
	"$package -- " FORMAL_VERSION,
	"Based on the original code written by Jarkko Oikarinen",
	"Copyright 1988, 1989, 1990, 1991 University of Uulu, Computing Center",
	" ",
	"This program is free software; you can redistribute it and/or",
	"modify it under the terms of the GNU General Public License as",
	"published by the Free Software Foundation; either version 1, or",
	"(at your option) any later version.",
	" ",
	"This version of RageIRCd was brought to you by the following people:",
	" ",
	"[-Th3Dud3-]       Alasdair McWilliam         th3dud3@turbo-irc.net",
	"Asmodai           Paul Ward                  asmodai@unixware.org.uk",
	"Dogbert           Kyle Williamson            dogbert@kammtech.co.uk",
	"Acidic32          Daniel Moss                daniel@ravehosts.co.uk",
	" ",
	"With thanks to the following people who have contributed their thoughts,",
	"ideas and bug reports into this version of RageIRCd:",
	" ",
	"[d4b0mb]          Jamie Chetta               jamie@turbo-irc.net",
	"Rob               David Robson               david.robson@virgin.net",
        "ReDeeMeR          Tom Squires                redeemer@turbo-irc.net",
	"eidkik            Carl Hollis                bonzo@mailbreak.com",
	"-                 Garry Millman              -",
	"reisa             -                          -",
	"Wazzerphuk        Glenn Wakeford             glenn@filmgeek.co.uk",
	"auspice           In Mean                    auspice@auspice.org",
	"aD_               -                          -",
	" ",
	"Thanks also goes to the people not listed above who have contributed",
	"to previous versions of RageIRCd.",
	" ",
	"RageIRCd was originally based on the StarChat IRCd v5.10.fx4, which was",
	"developed by the following people:",
	" ",
	"GZ                Maarten van den Bosch      gz@starchat.net",
	"InnerFIRE         Gerhard Mack               innerfire@starchat.net",
	"Ax0n              Paul de Regt               ax0n@starchat.net",
	"magician          Sean-Paul Rees             -",
	" ",
	"This IRCd also contains code developed by the following people:",
	" ",
	"Stskeeps          Carsten V. Munk            stskeeps@tspre.org",
	"codemastr         -                          codemastr@axenet.org",
        "binary            -                          garryb@binary.islesfan.net",
	"Lucas             Lucas Madar                lucas@netaverse.org",
	"-                 Gary S. Brown              -",
	" ",
	"The official RageIRCd website is: http://rageircd.sourceforge.net",
	" ",
	0,
};

!SUB!THIS!
